#include <libguile.h>
#include <libguile/__scm.h>

#include <g-wrap.h>
#include <ncurses/curses.h>
#include "curses.h"

/*[EXPORT (name COLORS)]
*/
int COLORS_ref(void)
{
  return COLORS;
};

/*[EXPORT (name COLOR-PAIRS)]
*/
int COLOR_PAIRS_ref(void)
{
  return COLOR_PAIRS;
};

/*[EXPORT (name stdscr)]
*/
WINDOW* stdscr_ref(void)
{
  return stdscr;
};

/*[EXPORT (name curscr)]
*/
WINDOW* curscr_ref(void)
{
  return curscr;
};

/*[EXPORT (name newscr)]
*/
WINDOW* newscr_ref(void)
{
  return newscr;
};

/*[EXPORT (name LINES)]
*/
int LINES_ref(void)
{
  return LINES;
};

/*[EXPORT (name COLS)]
*/
int COLS_ref(void)
{
  return COLS;
};

/*[EXPORT (name TABSIZE)]
*/
int TABSIZE_ref(void)
{
  return TABSIZE;
};

/*[EXPORT (name ESCDELAY)]
*/
int ESCDELAY_ref(void)
{
  return ESCDELAY;
};

/*[EXPORT (name acs-map)]
*/
chtype acs_map_ref(char a)
{
  return acs_map[a];
};

/*[EXPORT (name KEY_Fn)]
*/
int key_fn(int n)
{
  return KEY_F(n);
};

/* VT100 symbols begin here */
/*[EXPORT (name ACS_ULCORNER)]
*/
chtype acs_ULCORNER    (void){return acs_map['l'];};
/*[EXPORT (name ACS_LLCORNER)]
*/
chtype acs_LLCORNER    (void){return acs_map['m'];};
/*[EXPORT (name ACS_URCORNER)]
*/
chtype acs_URCORNER    (void){return acs_map['k'];};
/*[EXPORT (name ACS_LRCORNER)]
*/
chtype acs_LRCORNER    (void){return acs_map['j'];};
/*[EXPORT (name ACS_LTEE)]
*/
chtype acs_LTEE        (void){return acs_map['t'];};
/*[EXPORT (name ACS_RTEE)]
*/
chtype acs_RTEE        (void){return acs_map['u'];};
/*[EXPORT (name ACS_BTEE)]
*/
chtype acs_BTEE        (void){return acs_map['v'];};
/*[EXPORT (name ACS_TTEE)]
*/
chtype acs_TTEE        (void){return acs_map['w'];};
/*[EXPORT (name ACS_HLINE)]
*/
chtype acs_HLINE       (void){return acs_map['q'];};
/*[EXPORT (name ACS_VLINE)]
*/
chtype acs_VLINE       (void){return acs_map['x'];};
/*[EXPORT (name ACS_PLUS)]
*/
chtype acs_PLUS        (void){return acs_map['n'];};
/*[EXPORT (name ACS_S1)]
*/
chtype acs_S1          (void){return acs_map['o'];};
/*[EXPORT (name ACS_S9)]
*/
chtype acs_S9          (void){return acs_map['s'];};
/*[EXPORT (name ACS_DIAMOND)]
*/
chtype acs_DIAMOND     (void){return acs_map['`'];};
/*[EXPORT (name ACS_CKBOARD)]
*/
chtype acs_CKBOARD     (void){return acs_map['a'];};
/*[EXPORT (name ACS_DEGREE)]
*/
chtype acs_DEGREE      (void){return acs_map['f'];};
/*[EXPORT (name ACS_PLMINUS)]
*/
chtype acs_PLMINUS     (void){return acs_map['g'];};
/*[EXPORT (name ACS_BULLET)]
*/
chtype acs_BULLET      (void){return acs_map['~'];};
/* Teletype 5410v1 symbols begin here */
/*[EXPORT (name ACS_LARROW)]
*/
chtype acs_LARROW      (void){return acs_map[','];};
/*[EXPORT (name ACS_RARROW)]
*/
chtype acs_RARROW      (void){return acs_map['+'];};
/*[EXPORT (name ACS_DARROW)]
*/
chtype acs_DARROW      (void){return acs_map['.'];};
/*[EXPORT (name ACS_UARROW)]
*/
chtype acs_UARROW      (void){return acs_map['-'];};
/*[EXPORT (name ACS_BOARD)]
*/
chtype acs_BOARD       (void){return acs_map['h'];};
/*[EXPORT (name ACS_LANTERN)]
*/
chtype acs_LANTERN     (void){return acs_map['i'];};
/*[EXPORT (name ACS_BLOCK)]
*/
chtype acs_BLOCK       (void){return acs_map['0'];};

/*[EXPORT (name ACS_S3)]
*/
chtype acs_S3          (void){return acs_map['p'];};
/*[EXPORT (name ACS_S7)]
*/
chtype acs_S7          (void){return acs_map['r'];};
/*[EXPORT (name ACS_LEQUAL)]
*/
chtype acs_LEQUAL      (void){return acs_map['y'];};
/*[EXPORT (name ACS_GEQUAL)]
*/
chtype acs_GEQUAL      (void){return acs_map['z'];};
/*[EXPORT (name ACS_PI)]
*/
chtype acs_PI          (void){return acs_map['{'];};
/*[EXPORT (name ACS_NEQUAL)]
*/
chtype acs_NEQUAL      (void){return acs_map['|'];};
/*[EXPORT (name ACS_STERLING)]
*/
chtype acs_STERLING    (void){return acs_map['}'];};

/*[EXPORT (name ACS_BSSB)]
*/
chtype acs_BSSB        (void){return acs_ULCORNER();};
/*[EXPORT (name ACS_SSBB)]
*/
chtype acs_SSBB        (void){return acs_LLCORNER();};
/*[EXPORT (name ACS_BBSS)]
*/
chtype acs_BBSS        (void){return acs_URCORNER();};
/*[EXPORT (name ACS_SBBS)]
*/
chtype acs_SBBS        (void){return acs_LRCORNER();};
/*[EXPORT (name ACS_SBSS)]
*/
chtype acs_SBSS        (void){return acs_RTEE();};
/*[EXPORT (name ACS_SSSB)]
*/
chtype acs_SSSB        (void){return acs_LTEE();};
/*[EXPORT (name ACS_SSBS)]
*/
chtype acs_SSBS        (void){return acs_BTEE();};
/*[EXPORT (name ACS_BSSS)]
*/
chtype acs_BSSS        (void){return acs_TTEE();};
/*[EXPORT (name ACS_BSBS)]
*/
chtype acs_BSBS        (void){return acs_HLINE();};
/*[EXPORT (name ACS_SBSB)]
*/
chtype acs_SBSB        (void){return acs_VLINE();};
/*[EXPORT (name ACS_SSSS)]
*/
chtype acs_SSSS        (void){return acs_PLUS();};
